<template>
  <div class="detail_contain">
    <p class="now_page_title">我的应用 / 应用仓库 / <span>应用详情</span></p>
    <div class="info_contain">
      <service-header
        :data="service_header_arr"
        @deploy="deploy"
        @editapp="editapp"
        @unline="unline"
        @unsell="unsell"
      ></service-header>
      <div class="type_box">
        <div class="type_title">
          <div
            v-for="(item, index) in service_arr[now_user]"
            :key="index + 1000"
            class="type_select"
            @click="now_service = index"
            :style="
              now_service == index ? { borderBottom: '4px solid #f5ab4c' } : {}
            "
          >
            {{ item }}
          </div>
        </div>
        <div class="type_box_select">
           <mavon-editor v-model="list_arr" :boxShadow="false" :toolbarsFlag="false" :subfield="subfield" :defaultOpen="preview" :editable="false" v-if="now_service == 0"/>
          
          <div v-if="now_service == 1&&now_user == 0">
              <p style="color:#8890a7;">镜像列表：</p>
            <table-um
                :headers="header_arr"
                :datas="image_arr"
                :asyn_load1="asynLoad"
                isLoad="255px"
                @load_data="load_data"
                @actiondelete="actiondelete"
                ></table-um>
                <p>
                    <span class="addimage" @click="addImage">新增镜像</span>
                </p>
                <div v-if="addImageFlag">
                    <el-form ref="form" :rules="rules" :model="form" label-width="0px">
                        <el-form-item prop="name">
                            <p class="formname">镜像名称：</p>
                            <el-input v-model="form.name"></el-input>
                        </el-form-item>
                        <el-form-item prop="taps">
                            <p class="formname">镜像标签：</p>
                            <el-input v-model="form.taps"></el-input>
                        </el-form-item>
                        <el-form-item>
                            <p class="formname">上传镜像包：</p>
                            <!-- <upload-file :multiple="false" :max="1" :drag="true" :list="imgList" directory="app" @getNewList="getNewList"></upload-file> -->
                            <el-upload
                              class="upload-demo"
                              drag
                              action="/apaas/hubApi/image/upload"
                              :file-list="form.fileList"
                              ref="upload"
                              :auto-upload="false"
                              :on-success="upload_success"
                              :on-error="upload_error"
                              :data="anotherData"
                              :multiple="false">
                              <i class="el-icon-upload"></i>
                              <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
                            </el-upload>
                        </el-form-item>
                    </el-form>
                </div>
                <div class="savebtn" v-if="addImageFlag">
                    <el-button @click="submit_form('form')">保存</el-button>
                    <el-button @click="addImageFlag=false">取消</el-button>
                </div>
          </div>

          <div v-if="now_service == 2&&now_user == 0">
              <p style="color:#8890a7;">压缩包：</p>
              <p><img src="@/assets/imgs/ic_olddata.png" alt="" style="margin-right: 10px;">{{oldpag_name}} <span class="download" @click="down_load_zip">下载原压缩包</span> </p>
              <p style="color:#8890a7;margin:20px 0;">上传新的压缩包：</p>
              <div class="uploadtips">
                  <p style="margin-left:-11px;"><i class="el-icon-warning-outline"></i>压缩包上传提示：</p>
                  <p>1.必须包含以下文件：Chart.yaml，README.md，step.yaml，values.yaml，logo.png；</p>
                  <p>2.上述文件必须按照上述名称进行命名；</p>
                  <p>3.请将文件夹压缩为“.zip”、“.tgz”、“.tar.gz”格式，如：名称为redis-ha的文件夹压缩为redis-ha.zip。</p>
              </div>
                <el-upload
                  class="upload-demo"
                  drag
                  action="/apaas/hubApi/market/updateChart"
                  :file-list="fileList"
                  ref="upload1"
                  :auto-upload="false"
                  :on-success="upload_success"
                  :on-error="upload_error"
                  :data="anotherData1"
                  :multiple="false">
                  <i class="el-icon-upload"></i>
                  <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
                </el-upload>
                <div class="savebtn">
                    <el-button @click="save_zip">保存</el-button>
                    <el-button>取消</el-button>
                </div>
          </div>

          <div v-if="(now_service == 3&&now_user == 0)||(now_service == 1&&now_user !== 0)">
              <service-tab-comments 
              :is_app_detail="is_app_detail"
              :data="commentsData"
              :url="commentsUrl">
              </service-tab-comments>
          </div>
          
        </div>
      </div>
    </div>
    <dialog-action
      ref="myConfirm"
      :confirmOptions="tipsOptions"
    ></dialog-action>
  </div>
</template>

<script>
import infoList from "@/components/infoList";
import tableUm from "@/components/table/table-um";
import serviceHeader from "@/components/service-header";
import dialogAction from "@/components/dialog-action";
import uploadFile from '@/components/upload_file'
import serviceTabComments from '@/components/service-tabs/service-tab-comments'
import { getRole } from "@/utils/common";
import { mapGetters,mapState } from 'vuex'
export default {
  components: {
    infoList,
    tableUm,
    serviceHeader,
    dialogAction,
    uploadFile,
    serviceTabComments,
  },
  data() {
    return {
      now_user: 0, //0：普通用户，1：组织管理员，2：超级管理员
      buy_style: 0,
      preview:'preview',
      subfield:false,
      image_arr:[],
      now_page:1,
      total:0,
      anotherData:{},
      anotherData1:{},
      asynLoad:false,
      oldpag_name:'',
      imgList: [],
      imgList1: [],
      is_app_detail:true,
      commentsData:{
        avgScore:0,
        scoreStatic:{},
      },
      commentsUrl:'',
      form:{
          name: '',
          fileList:[],
          taps:''
      },
      fileList:[],
      rules:{
          name:[
              {required: true, message: '请输入镜像名称', trigger: 'blur'}
          ],
          taps:[
              {required: true, message: '请输入镜像标签', trigger: 'blur'}
          ]
      },
      tipsOptions: {
        title:'',
        message:"",
        btnSubmitText: "",
        btnCancelText: "",
        position: "",
      },
      service_arr: [
        ["基本信息", "镜像文件管理", "部署文件管理", "评分及评论"],
        ["基本信息", "评分及评论"],
        ["基本信息", "评分及评论"],
      ],
      service_header_arr: {
        name: "",
        first: [
          {
              "name": "在线状态",
              "text": ""
          },
          {
              "name": "应用类型",
              "text": ""
          },
          {
              "name": "业务领域",
              "text": ""
          }
        ],
        second: [
          {
              "name": "申请类型",
              "text": ""
          },
          {
              "name": "申请开发次数",
              "text": ""
          },
          {
              "name": "申请部署次数",
              "text": ""
          },
          {
              "name":"创建时间",
              "text":""
          }
        ],
        yydetail: '',
        xxdetail:'',
        aqdetail: true,
        fxdetail:false,
        url:'',
      },
      now_service: 0,
      header_arr: [
        {
          prop: "name",
          label: "镜像名称",
          minWidth: "33.33%",
          align: "center",
        },
        {
          prop: "tag",
          label: "版本号",
          minWidth: "33.33%",
          align: "center",
        },
        {
          label: "操作",
          type: "Button",
          align: "center",
          minWidth: "33.33%",
          btnList: [
            {
              type: "actiondelete",
              label: "删除",
            },
          ],
        },
      ],
      
      list_arr: '',
      appcode: "",
      addImageFlag:false
    };
  },
  computed:{
    ...mapGetters([
      'level',
    ]),
    ...mapState(['userInfo']),
  },
  watch: {

  },
  created() {
    if(this.userInfo){
      this.now_user = this.level
      this.getServiceInfo();
    }else{
      this.getCurrentUser()
    }
    this.asynLoad=false
    this.commentsUrl = `/apaas/hubApi/market/comments/${this.$route.params.id}`
    this.getServiceBaseInfo();
    this.get_image_list()
    this.get_options()
    this.get_file_name()
  },
  mounted() {},
  methods: {
    getCurrentUser() {
      this.$api.user.getNowUser().then(({ data }) => {
        if (data.success == 1) {
          console.log("--- user info ---");
          console.log(data.data);
          console.log("--- user info ---");
          this.$store.commit("userInfofun", data.data);
          this.now_user = this.level
          this.getServiceInfo();
           console.log(this.level);
        } else {
          console.log(data.errMsg);
        }
      });
    },
    addImage(){
        this.addImageFlag = true
    },
    down_load_zip(){
      const a = document.createElement('a'); // 创建a标签
      a.setAttribute('download', '');// download属性
      a.setAttribute('href', '/apaas/hubApi/market/download/'+this.$route.params.id);// href链接
      a.click();// 自执行点击事件
    },
    get_options(){
      this.$http.get(`/apaas/hubApi/market/comments/${this.$route.params.id}?limit=10&page=1`)
      .then((response)=>{
        if(response.data.success==1){
          console.log(response);
          var temp = {}
          response.data.data.overview.detail_counts.forEach(e => {
            temp[e.score]=e.count
          });
          this.commentsData={
            avgScore:response.data.data.overview.ave,
            scoreStatic:temp,
          }
        }
      })
    },
    submit_form(formName){
      this.$refs[formName].validate((valid) => {
          if (valid) {
            this.anotherData = {
              image_name:this.form.name,
              tag:this.form.taps
            }
            console.log(this.anotherData);
            this.$refs['upload'].submit()
          } else {
            console.log('error submit!!');
            return false;
          }
        });
    },
    save_zip(){
      this.anotherData1 = {
        app_id:this.$route.params.id
      }
      console.log(this.anotherData1);
      this.$refs['upload1'].submit()
    },
    upload_success(response, file, fileList){
      if(response.success == 1){
        this.$message.success('上传成功')
        this.get_image_list()
      }else{
        this.$message.error(response.errMsg)
      }
    },
    upload_error(){
      this.$message.error('上传失败')
    },
    load_data(){
      console.log(2222);
      this.asynLoad=false
      if(5*this.now_page<this.total){
        this.now_page = this.now_page + 1
        this.get_image_list()
      }
    },
    get_image_list(){
      this.$http.get(`/apaas/hubApi/image/imageUpList?page=${this.now_page}&size=5`)
      .then((response)=>{
        if(response.data.success==1){
          console.log(response);
          this.asynLoad=true
          this.image_arr.push(...response.data.data)
          this.total = response.data.total
        }
      })
    },
    get_file_name(){
      this.$http.get(`/apaas/hubApi/market/chartsName/${this.$route.params.id}`)
      .then((response)=>{
        if(response.data.success==1){
          console.log(response);
          this.oldpag_name = response.data.data
        }
      })
    },
    actiondelete(){
        this.tipsOptions= {
            title:'',
            message:"",
            btnSubmitText: "",
            btnCancelText: "",
            position: "",
        }
        this.tipsOptions.message="是否删除该数据"
        this.tipsOptions.confirmSubmit = () => {
            console.log("deleteItem - ");
            this.$refs.myConfirm.hideModel();
        };
        this.$refs.myConfirm.showModel();
    },
    change_up_state(url,state){
      this.$http.put(`${url}/${this.$route.params.id}/${state}`).then((response)=>{
        if(response.data.success == 1){
          this.$message.success('申请成功')
          setTimeout(()=>{
            this.getServiceInfo()
          },1000)
        }else{
          this.$message.error('申请失败')
        }
      }).catch((res)=>{
        this.$message.error('申请失败')
      })
    },
    deploy(){
        console.log('0000');
    },
    editapp(){
      this.$router.push(`${this.$route.path.split('detail')[0]}edit/${this.$route.params.id}`)
    },
    unline(val){
        console.log(val);
        this.tipsOptions= {
            title:'',
            message:"",
            btnSubmitText: "",
            btnCancelText: "",
            position: "",
        }
        if(val.xxdetail == '申请下线'){
          this.tipsOptions.message="该操作会将该应用从应用商店的平台应用区域下线至开发者应用区域，下线前需向超级管理员发送通知，超级管理员通过后此应用将下线至开发者应用区域。"
          this.tipsOptions.btnSubmitText="发送通知"
        }
        if(val.xxdetail == '申请上线'){
          this.tipsOptions.message="该操作会将该应用从应用商店开发者应用上线至平台应用"
          this.tipsOptions.btnSubmitText="确认"
        }
        this.tipsOptions.position="left"
        this.tipsOptions.confirmSubmit = () => {
            console.log("deleteItem - ");
            if(val.xxdetail == '申请下线'){
              this.change_up_state('/apaas/hubApi/market/platformStatus',3)
            }
            if(val.xxdetail == '申请上线'){
              this.change_up_state('/apaas/hubApi/market/platformStatus',1)
            }
            this.$refs.myConfirm.hideModel();
        };
        this.$refs.myConfirm.showModel();
    },
    unsell(val){
        console.log(val);
        this.tipsOptions= {
            title:'',
            message:"",
            btnSubmitText: "",
            btnCancelText: "",
            position: "",
        }
        if(val.yydetail == '申请下架'){
          this.tipsOptions.message="申请下架应用需要向组织管理员发送通知，组织管理员通过下架请求后该应用将从应用商店下架。"
          this.tipsOptions.btnSubmitText="发送通知"
        }
        if(val.yydetail == '申请上架'){
          this.tipsOptions.message="申请下架应用需要向组织管理员发送通知，组织管理员通过上架请求后该应用将在应用商店上架。"
          this.tipsOptions.btnSubmitText="确认"
        }
        this.tipsOptions.confirmSubmit = () => {
            console.log("deleteItem - ");
            if(val.yydetail == '申请下架'){
              this.change_up_state('/apaas/hubApi/market/deployStatus',3)
            }
            if(val.yydetail == '申请上架'){
              this.change_up_state('/apaas/hubApi/market/deployStatus',1)
            }
            this.$refs.myConfirm.hideModel();
        };
        this.$refs.myConfirm.showModel();
    },
    getServiceInfo() {
      this.$http
        .get("/apaas/hubApi/market/baseInfo?id="+this.$route.params.id)
        .then((response) => {
          if(response.data.success){
            let data = response.data.data;
            this.$set(this.service_header_arr, "name", data.app_name+'V'+data.version);
            this.$set(this.service_header_arr['first'][0], "text", data.online_state_name);
            this.$set(this.service_header_arr['first'][1], "text", data.type_name);
            this.$set(this.service_header_arr['first'][2], "text", data.ywly_name);
            this.$set(this.service_header_arr['second'][0], "text", data.apply_type_name);
            this.$set(this.service_header_arr['second'][1], "text", data.apply_times+'次');
            this.$set(this.service_header_arr['second'][2], "text", data.deploy_times+'次');
            this.$set(this.service_header_arr['second'][3], "text", data.create_date);
            this.$set(this.service_header_arr, "yydetail", '');
            this.$set(this.service_header_arr, "xxdetail", '');
            if(data.up_deploy_status==0){
              this.$set(this.service_header_arr, "yydetail", '申请上架');
            }else if(data.up_deploy_status==2){
              this.$set(this.service_header_arr, "yydetail", '申请下架');
            }
            if(data.up_platform_status==0){
              this.$set(this.service_header_arr, "xxdetail", '申请上线');
            }else if(data.up_platform_status==2){
              this.$set(this.service_header_arr, "xxdetail", '申请下线');
            }
            if(this.now_user == 0){
              this.$set(this.service_header_arr, "fxdetail", true);
            }
            if(this.now_user == 1){
              this.$set(this.service_header_arr, "xxdetail", '');
              this.$set(this.service_header_arr, "yydetail", '');
              this.$set(this.service_header_arr, "fxdetail", '');
              this.$set(this.service_header_arr, "aqdetail", false);
            }
            if(this.now_user == 2){
              this.$set(this.service_header_arr, "xxdetail", '');
              this.$set(this.service_header_arr, "yydetail", '');
              this.$set(this.service_header_arr, "aqdetail", true);
            }

            this.$set(this.service_header_arr, "url", data.logo);
          }
        })
        .catch(function(response) {});
    },
    
    getServiceBaseInfo() {
      this.$http
        .get("/apaas/hubApi/market/readme/"+this.$route.params.id)
        .then((response) => {
          let data = response.data.data;
          this.list_arr = data
        })
        .catch(function(response) {});
    },
    
  },
};
</script>

<style>
.savebtn .el-button {
  float: right;
  margin-left: 20px;
  letter-spacing: 2px;
}
.savebtn .el-button:nth-of-type(1) {
  background-color: #0f2683;
  color: #f8f9fd;
}
.savebtn .el-button:nth-of-type(2) {
  background-color: #c3caf8;
  color: #0f2683;
}
</style>
<style scoped>
.detail_contain {
  width: 100%;
  padding: 0 20px;
  height: calc(100% - 55px);
}
.info_contain {
  padding: 25px 20px;
  background-color: #fff;
  width: 100%;
  box-shadow: 0px 3px 6px 0px #f4f7fc;
  border-radius: 12px;
  min-height: calc(100% - 20px);
  margin-bottom: 20px;
}
.now_page_title {
  margin: 15px 0;
  color: #898d9e;
}
.now_page_title span {
  color: #242c43;
}
.type_box {
  width: 100%;
}
.type_title {
  width: 100%;
  height: 65px;
  line-height: 65px;
  border-bottom: 2px solid #f4f7fc;
}
.type_select {
  float: left;
  width: auto;
  margin-right: 40px;
  height: 65px;
  cursor: pointer;
}
.type_box_select {
  padding: 30px 10px 10px 10px;
  width: 100%;
}

.savebtn {
  margin-top: 50px;
  overflow: hidden;
}
.appcode {
  white-space: pre-wrap;
  width: 100%;
  background-color: #f8f9fd;
  border-radius: 8px;
  padding: 24px;
  color: #58617a;
}
.addimage,.download{
    display: inline-block;
    color: #f8f9fd;
    font-size: 16px;
    width: 124px;
    height: 44px;
    line-height: 44px;
    text-align: center;
	background-color: #0f2683;
    border-radius: 8px;
    margin-top: 20px;
    cursor: pointer;
}
.download{
    background-color: #495feb;
    margin-left: 10px;
}
.formname{
    color: #8890a7;
}
.uploadtips{
    width: 750px;
	height: 141px;
	background-color: #f8f9fd;
    border-radius: 8px;
    padding: 20px 40px;
    color: #8890a7;
    line-height: 22px;
    margin-bottom: 20px;
}

</style>
